<!DOCTYPE html>
<html lang="en-us">
<head>

  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <meta http-equiv="X-UA-Compatible" content="IE=edge">
  <meta name="generator" content="Source Themes Academic 3.1.0">
  <meta name="generator" content="Hugo 0.50" />
  <meta name="author" content="Jeremy Jackson">

  
  
  
  
    
  
  <meta name="description" content="Just doing some programming exercises in NodeJS.">

  
  <link rel="alternate" hreflang="en-us" href="https://ackso.net/project/exercises-for-programmers-2/">

  


  

  

  

  
  
  
  <meta name="theme-color" content="#2962ff">
  

  
  
  
  
    
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/twitter-bootstrap/4.1.3/css/bootstrap.min.css" integrity="sha256-eSi1q2PG6J7g7ib17yAaWMcrr5GrtohYChqibrV7PBE=" crossorigin="anonymous">
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/academicons/1.8.6/css/academicons.min.css" integrity="sha256-uFVgMKfistnJAfoCUQigIl+JfUaP47GrRKjf6CTPVmw=" crossorigin="anonymous">
    <link rel="stylesheet" href="https://use.fontawesome.com/releases/v5.5.0/css/all.css" integrity="sha384-B4dIYHKNBt8Bc12p+WXckhzcICo0wtJAoU8YZTY5qE0Id1GSseTk6S+L3BlXeVIU" crossorigin="anonymous">
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/fancybox/3.2.5/jquery.fancybox.min.css" integrity="sha256-ygkqlh3CYSUri3LhQxzdcm0n1EQvH2Y+U5S2idbLtxs=" crossorigin="anonymous">

    
    
    
      
    
    
      
      
        <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/highlight.js/9.12.0/styles/github.min.css" crossorigin="anonymous">
      
    

    

    

  

  
  
  <link rel="stylesheet" href="//fonts.googleapis.com/css?family=Montserrat:400,700|Roboto:400,400italic,700|Roboto+Mono">
  

  <link rel="stylesheet" href="/styles.css">
  

  
  
  

  
  <link rel="alternate" href="https://ackso.net/index.xml" type="application/rss+xml" title="Sometimes Jeremy Thinks">
  <link rel="feed" href="https://ackso.net/index.xml" type="application/rss+xml" title="Sometimes Jeremy Thinks">
  

  <link rel="manifest" href="/site.webmanifest">
  <link rel="icon" type="image/png" href="/img/icon.png">
  <link rel="apple-touch-icon" type="image/png" href="/img/icon-192.png">

  <link rel="canonical" href="https://ackso.net/project/exercises-for-programmers-2/">

  <meta property="twitter:card" content="summary_large_image">
  
  <meta property="og:site_name" content="Sometimes Jeremy Thinks">
  <meta property="og:url" content="https://ackso.net/project/exercises-for-programmers-2/">
  <meta property="og:title" content="Exercises for Programmers 2 - NODEJS | Sometimes Jeremy Thinks">
  <meta property="og:description" content="Just doing some programming exercises in NodeJS.">
  
  
    
  <meta property="og:image" content="https://ackso.net/img/icon-192.png">
  <meta property="og:locale" content="en-us">
  
  <meta property="article:published_time" content="2017-12-23T09:40:33-07:00">
  
  <meta property="article:modified_time" content="2017-12-23T09:40:33-07:00">
  

  

  

  <title>Exercises for Programmers 2 - NODEJS | Sometimes Jeremy Thinks</title>

</head>
<body id="top" data-spy="scroll" data-target="#TableOfContents" data-offset="71" >

<nav class="navbar navbar-light fixed-top navbar-expand-lg py-0" id="navbar-main">
  <div class="container">

    
      <a class="navbar-brand" href="/">Sometimes Jeremy Thinks</a>
      
      <button type="button" class="navbar-toggler" data-toggle="collapse"
              data-target="#navbar" aria-controls="navbar" aria-expanded="false" aria-label="Toggle navigation">
        <span><i class="fas fa-bars"></i></span>
      </button>
      

    
    <div class="collapse navbar-collapse" id="navbar">

      
      
      <ul class="navbar-nav ml-auto">
        

        

        
        
        
          
        

        <li class="nav-item">
          <a class="nav-link" href="/#about">
            
            <span>Home</span>
            
          </a>
        </li>

        
        

        

        
        
        
          
        

        <li class="nav-item">
          <a class="nav-link" href="/#posts">
            
            <span>Posts</span>
            
          </a>
        </li>

        
        

        

        
        
        
          
        

        <li class="nav-item">
          <a class="nav-link" href="/#projects">
            
            <span>Projects</span>
            
          </a>
        </li>

        
        

        

        
        
        
          
        

        <li class="nav-item">
          <a class="nav-link" href="/#contact">
            
            <span>Contact</span>
            
          </a>
        </li>

        
        

      

        

        
      </ul>

    </div>
  </div>
</nav>


<article class="article article-project" itemscope itemtype="http://schema.org/Article">

  












  

  
  
  
<div class="article-container pt-3">
  <h1 itemprop="name">Exercises for Programmers 2 - NODEJS</h1>

  

  
    

<div class="article-metadata">

  
  
  <span itemscope itemprop="author" itemtype="http://schema.org/Person">
    <meta itemprop="name" content="Jeremy Jackson">
  </span>
  

  <span class="article-date">
    
    <meta content="2017-12-23 09:40:33 -0700 MST" itemprop="datePublished">
    <time datetime="2017-12-23 09:40:33 -0700 MST" itemprop="dateModified">
      2017-12-23
    </time>
  </span>
  <span itemscope itemprop="publisher" itemtype="http://schema.org/Person">
    <meta itemprop="name" content="Jeremy Jackson">
  </span>

  

  
  
  <span class="middot-divider"></span>
  <a href="/project/exercises-for-programmers-2/#disqus_thread"></a>
  

  

  
  
<div class="share-box" aria-hidden="true">
  <ul class="share">
    <li>
      <a class="twitter"
         href="https://twitter.com/intent/tweet?text=Exercises%20for%20Programmers%202%20-%20NODEJS&amp;url=https%3a%2f%2fackso.net%2fproject%2fexercises-for-programmers-2%2f"
         target="_blank" rel="noopener">
        <i class="fab fa-twitter"></i>
      </a>
    </li>
    <li>
      <a class="facebook"
         href="https://www.facebook.com/sharer.php?u=https%3a%2f%2fackso.net%2fproject%2fexercises-for-programmers-2%2f"
         target="_blank" rel="noopener">
        <i class="fab fa-facebook-f"></i>
      </a>
    </li>
    <li>
      <a class="linkedin"
         href="https://www.linkedin.com/shareArticle?mini=true&amp;url=https%3a%2f%2fackso.net%2fproject%2fexercises-for-programmers-2%2f&amp;title=Exercises%20for%20Programmers%202%20-%20NODEJS"
         target="_blank" rel="noopener">
        <i class="fab fa-linkedin-in"></i>
      </a>
    </li>
    <li>
      <a class="weibo"
         href="http://service.weibo.com/share/share.php?url=https%3a%2f%2fackso.net%2fproject%2fexercises-for-programmers-2%2f&amp;title=Exercises%20for%20Programmers%202%20-%20NODEJS"
         target="_blank" rel="noopener">
        <i class="fab fa-weibo"></i>
      </a>
    </li>
    <li>
      <a class="email"
         href="mailto:?subject=Exercises%20for%20Programmers%202%20-%20NODEJS&amp;body=https%3a%2f%2fackso.net%2fproject%2fexercises-for-programmers-2%2f">
        <i class="fas fa-envelope"></i>
      </a>
    </li>
  </ul>
</div>


  

</div>

    















  
</div>



  <div class="article-container">

    <div class="article-style" itemprop="articleBody">
      

<p>It took a couple days (because I was doing them in bed before going to sleep),
but I just finished up Chapter 2 of
<a href="https://pragprog.com/book/bhwb/exercises-for-programmers" target="_blank">Exercises for Programmers</a>.</p>

<h2>Table of Contents</h2>
<nav id="TableOfContents">
<ul>
<li><a href="#background-and-thinking">Background and Thinking</a></li>
<li><a href="#package-json"><code>package.json</code></a></li>
<li><a href="#tests">Tests</a></li>
<li><a href="#exercise-1">Exercise 1</a></li>
<li><a href="#exercise-2">Exercise 2</a></li>
<li><a href="#exercise-3">Exercise 3</a></li>
<li><a href="#exercise-4">Exercise 4</a></li>
<li><a href="#exercise-5">Exercise 5</a></li>
<li><a href="#exercise-6">Exercise 6</a></li>
</ul>
</nav>


<h1 id="background-and-thinking">Background and Thinking</h1>

<p>This chapter is where you actually start in on working on the advertised &ldquo;57 exercises&rdquo;.
It really does want you to be able to run these exercises as stand-alone command-line
programs (and challenges you to also implement in them in various ways, such as with a GUI),
so I decided to yield and get in on Node&rsquo;s <code>readline</code> package.
<code>readline</code> is stream-based, so you have a couple of options in how you get it working.
I opted for the callback-style rather than using <code>pipe</code>, but if I ever go back and refactor
this stuff I&rsquo;ll be implementing <code>pipe</code> so that the code can be cleaner.</p>

<p>In order to make testing easier I broke each exercise down into two pieces: a function that
takes the inputs and produces the desired outputs, and a script that implements <code>readlines</code>
to ask the user questions, calls the aforementioned function, and then <code>console.log()</code>s the
output.</p>

<p>I also made a single test file for the whole chapter to keep all these exercises together.
I&rsquo;m still only testing the functions themselves, but I&rsquo;m investigating methods for testing
the <code>readline</code> scripts as well so that I can also test the interactions between the functions
and their calling scripts.
So far I&rsquo;ve only found a couple of blog posts that explain how to do it, but the methods
being implemented seem to all be pretty verbose and require some finnagling and/or refactoring
the <code>readline</code> into a <code>Promise</code>.
I&rsquo;ll probably look into how different packages that provide cli interactivity do this, like
<code>eslint</code>.</p>

<p>While reading up on <code>readline</code> I also found out about <code>npm link</code>, and I&rsquo;m really excited for it.
<code>npm link</code> looks for the <code>bin</code> object in your <code>package.json</code> and then creates a symlink from
<code>/usr/bin/&lt;key&gt;</code> to <code>~/mydir/&lt;value&gt;.js</code>.
That way you can have your Node scripts run as if they were actual command line programs
that can be called by name rather than by running <code>node &lt;file&gt;.js --arguments ...</code>.
One thing to keep in mind is that <code>npm link</code> may break your legitimate functions in <code>/usr/bin</code>
by creating that symlink.
To avoid that, I added <code>-js</code> to the end of each of my keys in the <code>bin</code> object so that it
would never conflict with or break things.
This was the thing I was definitely most excited about learning during this whole chapter.</p>

<p><a href="https://github.com/jeremy-j-ackso/exercises-for-programmers-nodejs" target="_blank">My repo</a> for this
continues to grow. I think I&rsquo;m going to skip branching on this until I start going back for
refactors.</p>

<h1 id="package-json"><code>package.json</code></h1>

<p>I&rsquo;m just going to drop in my <code>bin</code> object to keep things short(er).</p>

<pre><code class="language-javascript">&quot;bin&quot;: {
  &quot;hello-js&quot;: &quot;./ch2/hello.js&quot;,
  &quot;countChars-js&quot;: &quot;./ch2/countChars.js&quot;,
  &quot;quote-js&quot;: &quot;./ch2/quote.js&quot;,
  &quot;madlib-js&quot;: &quot;./ch2/madlib.js&quot;,
  &quot;simplemath-js&quot;: &quot;./ch2/simplemath.js&quot;,
  &quot;retirement-js&quot;: &quot;./ch2/retirement.js&quot;
}
</code></pre>

<h1 id="tests">Tests</h1>

<p>As I mentioned, I dropped everything from this chapter into a single test file so that they
would be grouped together in my mocha output.</p>

<pre><code class="language-javascript">/* eslint no-undef: &quot;off&quot;, no-sparse-arrays: &quot;off&quot;, comma-spacing: &quot;off&quot;, comma-dangle: &quot;off&quot; */

const expect = require('expect.js')

const hellof = require('../ch2/ex1.js')
const countChars = require('../ch2/ex2.js')
const quote = require('../ch2/ex3.js')
const madlib = require('../ch2/ex4.js')
const simplemath = require('../ch2/ex5.js')
const retirement = require('../ch2/ex6.js')

describe('ch2', () =&gt; {
  describe('ex1.js', () =&gt; {
    it('should return values equal to reference.', () =&gt; {
      const ref_test = [
        { args: 'Jeremy', expect: 'Hello, Jeremy, nice to meet you!' },
        { args: 'Sue', expect: 'Hello, Sue, nice to meet you!' },
        { args: 'Bob', expect: 'Hello, Bob, nice to meet you!' },
        { args: 'Ana', expect: 'Hello, Ana, nice to meet you!' },
        { args: 'Tom', expect: 'Hello, Tom, nice to meet you!' },
        { args: '5', expect: 'Hello, 5, nice to meet you!' },
      ]
      ref_test.forEach((test) =&gt; {
        expect(hellof(test.args)).to.eql(test.expect)
      })
    })

    it('should throw an error if not given a string', () =&gt; {
      const err_test = [
        { args: undefined },
        { args: null },
        { args: 5 },
      ]
      err_test.forEach((test) =&gt; {
        expect(hellof).withArgs(test.args).to.throwError('name should be a string')
      })
    })
  })

  describe('ex2.js', () =&gt; {
    it('should return values equal to reference', () =&gt; {
      const ref_test = [
        { args: 'Jeremy', expect: 6 },
        { args: 'bob', expect: 3 },
        { args: 'eleventy-one', expect: 12 },
      ]
      ref_test.forEach((test) =&gt; {
        expect(countChars(test.args)).to.equal(test.expect)
      })
    })

    it('should throw an error if not given a string', () =&gt; {
      const err_test = [
        { args: undefined },
        { args: null },
        { args: 5 },
      ]
      err_test.forEach((test) =&gt; {
        expect(countChars).withArgs(test.args).to.throwError('inputString should be a string')
      })
    })
  })

  describe('ex3.js', () =&gt; {
    it('should return values equal to reference', () =&gt; {
      const ref_test = [
        { args: ['bob', 'Hi.'], expect: 'bob says, &quot;Hi.&quot;' },
        { args: ['Joe', 'Hello.'], expect: 'Joe says, &quot;Hello.&quot;' },
        { args: ['R2D2', 'beep-bloop'], expect: 'R2D2 says, &quot;beep-bloop&quot;' },
      ]
      ref_test.forEach((test) =&gt; {
        expect(quote(test.args[0], test.args[1])).to.equal(test.expect)
      })
    })

    it('should throw an error if an argument is empty, undefined, or null', () =&gt; {
      const err_test = [
        { args: [,] },
        { args: [, 'hi'] },
        { args: ['hi',] },
        { args: [null, null] },
        { args: [null, 'hi'] },
        { args: ['hi', null] },
        { args: [undefined, undefined] },
        { args: [undefined, 'hi'] },
        { args: ['hi', undefined] },
      ]
      err_test.forEach((test) =&gt; {
        expect(quote).withArgs(test.args[0], test.args[1]).to.throwError('all arguments must be strings')
      })
    })

    it('should throw an error if an argument is not a string', () =&gt; {
      const err_test = [
        { args: [1, 'hi'] },
        { args: ['hi', 1] },
        { args: [1, 1] },
      ]
      err_test.forEach((test) =&gt; {
        expect(quote).withArgs(test.args[0], test.args[1]).to.throwError('all arguments must be strings')
      })
    })
  })

  describe('ex4.js', () =&gt; {
    it('should return values equal to reference', () =&gt; {
      const ref_test = [
        { args: ['dog', 'walk', 'blue', 'quickly'], expect: 'Do you walk your blue dog quickly? That\'s hilarious!' },
        { args: ['cat', 'jump', 'lithe', 'anxiously'], expect: 'Do you jump your lithe cat anxiously? That\'s hilarious!' },
        { args: ['noun', 'verb', 'adjective', 'adverb'], expect: 'Do you verb your adjective noun adverb? That\'s hilarious!' },
      ]
      ref_test.forEach((test) =&gt; {
        expect(madlib(test.args[0], test.args[1], test.args[2], test.args[3])).to.equal(test.expect)
      })
    })

    it('should throw an error if an argument is empty, undefined, or null', () =&gt; {
      const err_test = [
        { args: [,,,] },
        { args: [, 'hi',,] },
        { args: ['hi',,,] },
        { args: [null, null, null, null] },
        { args: [null, 'hi', null, null] },
        { args: ['hi', null, null, null] },
        { args: [undefined, undefined, undefined, undefined] },
        { args: [undefined, 'hi', undefined, undefined] },
        { args: ['hi', undefined, undefined, undefined] },
      ]
      err_test.forEach((test) =&gt; {
        expect(madlib).withArgs(test.args[0], test.args[1], test.args[2], test.args[3]).to.throwError('all arguments must be strings')
      })
    })

    it('should throw an error if an argument is not a string', () =&gt; {
      const err_test = [
        { args: [1, 'hi', 'hi', 'hi'] },
        { args: ['hi', 1, 'hi', 'hi'] },
        { args: [1, 1, 1, 1] },
      ]
      err_test.forEach((test) =&gt; {
        expect(madlib).withArgs(test.args[0], test.args[1]).to.throwError('all arguments must be strings')
      })
    })
  })

  describe('ex5.js', () =&gt; {
    it('should return values equal to reference', () =&gt; {
      const ref_test = [
        { args: ['1', '2'], expect: '1 + 2 = 3\n1 - 2 = -1\n1 * 2 = 2\n1 / 2 = 0.5' },
        { args: ['8', '3'], expect: '8 + 3 = 11\n8 - 3 = 5\n8 * 3 = 24\n8 / 3 = 2.67' },
        { args: ['19', '1'], expect: '19 + 1 = 20\n19 - 1 = 18\n19 * 1 = 19\n19 / 1 = 19' },
      ]
      ref_test.forEach((test) =&gt; {
        expect(simplemath(test.args[0], test.args[1])).to.equal(test.expect)
      })
    })

    it('should throw an error if the string input cannot be coerced to a number', () =&gt; {
      const err_test = [
        { args: ['one', '1'] },
        { args: ['1', 'one'] },
        { args: ['one', 'one'] },
      ]
      err_test.forEach((test) =&gt; {
        expect(simplemath).withArgs(test.args[0], test.args[1]).to.throwError('inputs must be digits')
      })
    })

    it('should throw an error if the input is actually a number and not a string', () =&gt; {
      const err_test = [
        { args: [1, 1] },
        { args: ['one', 1] },
        { args: [1, 'one'] },
      ]
      err_test.forEach((test) =&gt; {
        expect(simplemath).withArgs(test.args[0], test.args[1]).to.throwError('inputs must be digits')
      })
    })

    it('should throw an error if inputs are null or undefined', () =&gt; {
      const err_test = [
        { args: [,] },
        { args: [undefined,] },
        { args: [, undefined] },
        { args: [undefined, undefined] },
        { args: [null,] },
        { args: [, null] },
        { args: [null, null] },
      ]
      err_test.forEach((test) =&gt; {
        expect(simplemath).withArgs(test.args[0], test.args[1]).to.throwError('inputs must be digits')
      })
    })
  })

  describe('ex6.js', () =&gt; {
    it('should return values equal to reference', () =&gt; {
      const ref_test = [
        { args: ['20', '40'], expect: 'You have 20 years left until you can retire.\nIt\'s 2017, so you can retire in 2037.' },
        { args: ['20', '60'], expect: 'You have 40 years left until you can retire.\nIt\'s 2017, so you can retire in 2057.' },
      ]
      ref_test.forEach((test) =&gt; {
        expect(retirement(test.args[0], test.args[1])).to.equal(test.expect)
      })
    })

    it('should throw an error if the input is actually a number and not a string', () =&gt; {
      const err_test = [
        { args: [1, 1] },
        { args: ['one', 1] },
        { args: [1, 'one'] },
      ]
      err_test.forEach((test) =&gt; {
        expect(simplemath).withArgs(test.args[0], test.args[1]).to.throwError('inputs must be digits')
      })
    })

    it('should throw an error if inputs are null or undefined', () =&gt; {
      const err_test = [
        { args: [,] },
        { args: [undefined,] },
        { args: [, undefined] },
        { args: [undefined, undefined] },
        { args: [null,] },
        { args: [, null] },
        { args: [null, null] },
      ]
      err_test.forEach((test) =&gt; {
        expect(simplemath).withArgs(test.args[0], test.args[1]).to.throwError('inputs must be digits')
      })
    })
  })
})
</code></pre>

<h1 id="exercise-1">Exercise 1</h1>

<p>Exercise 1 was just a simple &ldquo;Hello Bob!&rdquo; kind of thing.</p>

<p>Here&rsquo;s <code>ex1.js</code>:</p>

<pre><code class="language-javascript">function hello(name) {
  if (typeof name !== 'string') throw new Error('name should be a string')
  return `Hello, ${name}, nice to meet you!`
}

module.exports = hello
</code></pre>

<p>Here&rsquo;s it&rsquo;s calling script, <code>hello.js</code>:</p>

<pre><code class="language-javascript">#!/usr/bin/node

const readline = require('readline')
const hellof = require('./ex1.js')

const rl = readline.createInterface({
  input: process.stdin,
  output: process.stdout,
})

rl.question('What is your name? ', (name) =&gt; {
  const response = hellof(name)
  console.log(response)
  rl.close()
})
</code></pre>

<h1 id="exercise-2">Exercise 2</h1>

<p>Exercise 2 outputs the number of characters in a string.</p>

<p>Here&rsquo;s <code>ex2.js</code>:</p>

<pre><code class="language-javascript">function countChars(inputString) {
  if (typeof inputString !== 'string') throw new Error('inputString should be a string')
  const chars = inputString.length
  return chars
}

module.exports = countChars
</code></pre>

<p>Here&rsquo;s it&rsquo;s calling script, <code>countChars.js</code>:</p>

<pre><code class="language-javascript">#!/usr/bin/node

const readline = require('readline')
const countChars = require('./ex2.js')

const rl = readline.createInterface({
  input: process.stdin,
  output: process.stdout,
})

rl.question('What is the input string? ', (inputString) =&gt; {
  const response = countChars(inputString)
  console.log(`${inputString}: ${response}`)
  rl.close()
})
</code></pre>

<h1 id="exercise-3">Exercise 3</h1>

<p>This exercise asks two questions, which is where taking advantage of <code>pipe</code> with these
streams starts to show its usefulness. You give it a quote and who said it, and
it puts them together in a single string.</p>

<p>Here <code>ex3.js</code></p>

<pre><code class="language-javascript">/* eslint prefer-template: &quot;off&quot; */

// prefer-template is switched off because the book says to use concatenation.

function quote(author, qte) {
  if (typeof author !== 'string') throw new Error('all arguments must be strings')
  if (typeof qte !== 'string') throw new Error('all arguments must be strings')
  return author + ' says, &quot;' + qte + '&quot;'
}

module.exports = quote
</code></pre>

<p>Here&rsquo;s its calling script, <code>quote.js</code>:</p>

<pre><code class="language-javascript">#!/usr/bin/node

const readline = require('readline')
const quote = require('./ex3.js')

const rl = readline.createInterface({
  input: process.stdin,
  output: process.stdout,
})

rl.question('What is the quote? ', (inputQuote) =&gt; {
  rl.question('Who said it? ', (inputSpeaker) =&gt; {
    const response = quote(inputSpeaker, inputQuote)
    console.log(response)
    rl.close()
  })
})
</code></pre>

<h1 id="exercise-4">Exercise 4</h1>

<p>This exercise does a basic madlibs-style of string creation. With 4 inputs, I&rsquo;m definitely
seeing callback hell start to creep into the <code>readline</code> block.</p>

<p>Here&rsquo;s <code>ex4.js</code>:</p>

<pre><code class="language-javascript">function madlib(noun, verb, adjective, adverb) {
  if (typeof noun !== 'string' || typeof verb !== 'string' ||
    typeof adjective !== 'string' || typeof adverb !== 'string') {
    throw new Error('all arguments must be strings')
  }
  return `Do you ${verb} your ${adjective} ${noun} ${adverb}? That's hilarious!`
}

module.exports = madlib
</code></pre>

<p>Here&rsquo;s its calling script <code>madlib.js</code>:</p>

<pre><code class="language-javascript">#!/usr/bin/node

const readline = require('readline')
const madlib = require('../ch2/ex4.js')


const rl = readline.createInterface({
  input: process.stdin,
  output: process.stdout,
})

let builder = {}
rl.question('Enter a noun: ', (noun) =&gt; {
  builder.noun = noun
  rl.question('Enter a verb: ', (verb) =&gt; {
    builder.verb = verb
    rl.question('Enter an adjective: ', (adjective) =&gt; {
      builder.adjective = adjective
      rl.question('Enter an adverb: ', (adverb) =&gt; {
        builder.adverb = adverb
        console.log(madlib(builder.noun, builder.verb, builder.adjective, builder.adverb))
        rl.close()
      })
    })
  })
})
</code></pre>

<h1 id="exercise-5">Exercise 5</h1>

<p>This one does the basic four arithmetic functions on two input numbers.
I can probably refactor how I&rsquo;m producing the output string to be a bit more elegant and shorter
(I&rsquo;m thinking string concatenation with array destructuring), but this is fine for a
first stab at it.</p>

<p>Here&rsquo;s <code>ex5.js</code>:</p>

<pre><code class="language-javascript">/* eslint no-restricted-globals: &quot;off&quot; */

function simplemath(firstNum, secondNum) {
  if (isNaN(Number(firstNum))) throw new Error('inputs must be digits')
  if (isNaN(Number(secondNum))) throw new Error('inputs must be digits')

  if (typeof firstNum !== 'string') throw new Error('inputs must be digits')
  if (typeof secondNum !== 'string') throw new Error('inputs must be digits')

  const fnum = Number(firstNum)
  const snum = Number(secondNum)

  let mathObj = {
    add: fnum + snum,
    subtract: fnum - snum,
    multiply: fnum * snum,
    divide: fnum / snum,
  }

  mathObj.divide = parseFloat(mathObj.divide.toFixed(2))

  return `${fnum} + ${snum} = ${mathObj.add}\n${fnum} - ${snum} = ${mathObj.subtract}\n${fnum} * ${snum} = ${mathObj.multiply}\n${fnum} / ${snum} = ${mathObj.divide}`
}

module.exports = simplemath
</code></pre>

<p>Here&rsquo;s its calling script <code>simplemath.js</code>:</p>

<pre><code class="language-javascript">#!/usr/bin/node

const readline = require('readline')
const simplemath = require('./ex5.js')

const rl = readline.createInterface({
  input: process.stdin,
  output: process.stdout,
})

let values = {}
rl.question('What is the first number? ', (firstNumber) =&gt; {
  values.firstNumber = firstNumber
  rl.question('What is the second number? ', (secondNumber) =&gt; {
    values.secondNumber = secondNumber
    console.log(simplemath(values.firstNumber, values.secondNumber))
    rl.close()
  })
})
</code></pre>

<h1 id="exercise-6">Exercise 6</h1>

<p>This exercise starts incorporating <code>Date()</code> and doing math with that. Other than that, it&rsquo;s
pretty much the same as the others.</p>

<p>Here&rsquo;s <code>ex6.js</code>:</p>

<pre><code class="language-javascript">/* eslint no-restricted-globals: &quot;off&quot; */

function retirement(currentAge, retirementAge) {
  if (isNaN(Number(currentAge))) throw new Error('inputs must be digits')
  if (isNaN(Number(retirementAge))) throw new Error('inputs must be digits')

  if (typeof currentAge !== 'string') throw new Error('inputs must be digits')
  if (typeof retirementAge !== 'string') throw new Error('inputs must be digits')

  const years = retirementAge - currentAge
  const curYear = new Date().getFullYear()
  const retYear = curYear + years
  return `You have ${years} years left until you can retire.\nIt's ${curYear}, so you can retire in ${retYear}.`
}

module.exports = retirement
</code></pre>

<p>Here&rsquo;s its calling script, <code>retirement.js</code>:</p>

<pre><code class="language-javascript">#!/usr/bin/node

const readline = require('readline')
const retirement = require('./ex6.js')

const rl = readline.createInterface({
  input: process.stdin,
  output: process.stdout,
})

let values = {}
rl.question('What is your current age? ', (firstNumber) =&gt; {
  values.firstNumber = firstNumber
  rl.question('At what age would you like to retire? ', (secondNumber) =&gt; {
    values.secondNumber = secondNumber
    console.log(retirement(values.firstNumber, values.secondNumber))
    rl.close()
  })
})
</code></pre>

    </div>

    


<div class="article-tags">
  
  <a class="badge badge-light" href="/tags/programming-exercises/">programming exercises</a>
  
  <a class="badge badge-light" href="/tags/nodejs/">nodejs</a>
  
</div>



    






<div class="media author-card" itemscope itemtype="http://schema.org/Person">
  
  <img class="portrait mr-3" src="/img/portrait.jpg" itemprop="image" alt="Avatar">
  
  <div class="media-body">
    <h5 class="card-title" itemprop="name"><a href="/">Jeremy Jackson</a></h5>
    <h6 class="card-subtitle">Software Engineering and Data Science</h6>
    
    <ul class="network-icon" aria-hidden="true">
      
      
      
      
      
      
      
      
      <li>
        <a itemprop="sameAs" href="mailto:jeremy_j@ackso.net" >
          <i class="fa fa-envelope"></i>
        </a>
      </li>
      
      
      
      
        
      
      
      
      
      
        
      
      <li>
        <a itemprop="sameAs" href="//twitter.com/jeremy_j_ackso" >
          <i class="fab fa-twitter"></i>
        </a>
      </li>
      
      
      
      
        
      
      
      
      
      
        
      
      <li>
        <a itemprop="sameAs" href="//github.com/jeremy-j-ackso" >
          <i class="fab fa-github"></i>
        </a>
      </li>
      
      
      
      
        
      
      
      
      
      
        
      
      <li>
        <a itemprop="sameAs" href="//gitlab.com/jeremy.jackson" >
          <i class="fab fa-gitlab"></i>
        </a>
      </li>
      
      
      
      
        
      
      
      
      
      
        
      
      <li>
        <a itemprop="sameAs" href="//linkedin.com/in/jeremy-jackson-249878153" >
          <i class="fab fa-linkedin"></i>
        </a>
      </li>
      
    </ul>
  </div>
</div>




    
    
    
    
    
    
    

    

      
      
      

      
      
      
      

      
      
      
      
    

  </div>
</article>



<div class="container">
  <footer class="site-footer">
  

  <p class="powered-by">
    &copy; 2017 Jeremy T Jackson &middot; 

    Powered by the
    <a href="https://sourcethemes.com/academic/" target="_blank" rel="noopener">Academic theme</a> for
    <a href="https://gohugo.io" target="_blank" rel="noopener">Hugo</a>.

    
    <span class="float-right" aria-hidden="true">
      <a href="#" id="back_to_top">
        <span class="button_icon">
          <i class="fas fa-chevron-up fa-2x"></i>
        </span>
      </a>
    </span>
    
  </p>
</footer>

</div>


<div id="modal" class="modal fade" role="dialog">
  <div class="modal-dialog">
    <div class="modal-content">
      <div class="modal-header">
        <h5 class="modal-title">Cite</h5>
        <button type="button" class="close" data-dismiss="modal" aria-label="Close">
          <span aria-hidden="true">&times;</span>
        </button>
      </div>
      <div class="modal-body">
        <pre><code class="tex hljs"></code></pre>
      </div>
      <div class="modal-footer">
        <a class="btn btn-outline-primary my-1 js-copy-cite" href="#" target="_blank">
          <i class="fas fa-copy"></i> Copy
        </a>
        <a class="btn btn-outline-primary my-1 js-download-cite" href="#" target="_blank">
          <i class="fas fa-download"></i> Download
        </a>
        <div id="modal-error"></div>
      </div>
    </div>
  </div>
</div>

    

    
    
    
    
    <script src="/js/mathjax-config.500a6cbb2c0f345fcecc21b3116d6637aa78f1f11db8081ea581abe05390c2e8f3bbffe61be3cf0217baf785c40efceabe51050a4f007e69af94efd3643260e8.js" integrity="sha512-UApsuywPNF/OzCGzEW1mN6p48fEduAgepYGr4FOQwujzu//mG&#43;PPAhe694XEDvzqvlEFCk8AfmmvlO/TZDJg6A=="></script>
    

    
    
    
      <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.3.1/jquery.min.js" integrity="sha512-+NqPlbbtM1QqiK8ZAo4Yrj2c4lNQoGv8P79DPtKzj++l5jnN39rHA/xsqn8zE9l0uSoxaCdrOgFs6yjyfbBxSg==" crossorigin="anonymous"></script>
      <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery.imagesloaded/4.1.3/imagesloaded.pkgd.min.js" integrity="sha512-umsR78NN0D23AzgoZ11K7raBD+R6hqKojyBZs1w8WvYlsI+QuKRGBx3LFCwhatzBunCjDuJpDHwxD13sLMbpRA==" crossorigin="anonymous"></script>
      <script src="https://cdnjs.cloudflare.com/ajax/libs/twitter-bootstrap/4.1.3/js/bootstrap.min.js" integrity="sha256-VsEqElsCHSGmnmHXGQzvoWjWwoznFSZc6hs7ARLRacQ=" crossorigin="anonymous"></script>
      <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery.isotope/3.0.4/isotope.pkgd.min.js" integrity="sha512-VDBOIlDbuC4VWxGJNmuFRQ0Li0SKkDpmGyuhAG5LTDLd/dJ/S0WMVxriR2Y+CyPL5gzjpN4f/6iqWVBJlht0tQ==" crossorigin="anonymous"></script>
      <script src="https://cdnjs.cloudflare.com/ajax/libs/fancybox/3.2.5/jquery.fancybox.min.js" integrity="sha256-X5PoE3KU5l+JcX+w09p/wHl9AzK333C4hJ2I9S5mD4M=" crossorigin="anonymous"></script>

      
        
        <script src="https://cdnjs.cloudflare.com/ajax/libs/highlight.js/9.12.0/highlight.min.js" integrity="sha256-/BfiIkHlHoVihZdc6TFuj7MmJ0TWcWsMXkeDFwhi0zw=" crossorigin="anonymous"></script>
        
        <script src="//cdnjs.cloudflare.com/ajax/libs/highlight.js/9.12.0/languages/python.min.js"></script>
        
        <script src="//cdnjs.cloudflare.com/ajax/libs/highlight.js/9.12.0/languages/r.min.js"></script>
        
        <script src="//cdnjs.cloudflare.com/ajax/libs/highlight.js/9.12.0/languages/bash.min.js"></script>
        
        <script src="//cdnjs.cloudflare.com/ajax/libs/highlight.js/9.12.0/languages/css.min.js"></script>
        
        <script src="//cdnjs.cloudflare.com/ajax/libs/highlight.js/9.12.0/languages/diff.min.js"></script>
        
        <script src="//cdnjs.cloudflare.com/ajax/libs/highlight.js/9.12.0/languages/javascript.min.js"></script>
        
        <script src="//cdnjs.cloudflare.com/ajax/libs/highlight.js/9.12.0/languages/json.min.js"></script>
        
        <script src="//cdnjs.cloudflare.com/ajax/libs/highlight.js/9.12.0/languages/markdown.min.js"></script>
        
        <script src="//cdnjs.cloudflare.com/ajax/libs/highlight.js/9.12.0/languages/nginx.min.js"></script>
        
        <script src="//cdnjs.cloudflare.com/ajax/libs/highlight.js/9.12.0/languages/processing.min.js"></script>
        
        <script src="//cdnjs.cloudflare.com/ajax/libs/highlight.js/9.12.0/languages/scala.min.js"></script>
        
        <script src="//cdnjs.cloudflare.com/ajax/libs/highlight.js/9.12.0/languages/sql.min.js"></script>
        
        <script src="//cdnjs.cloudflare.com/ajax/libs/highlight.js/9.12.0/languages/tex.min.js"></script>
        
        <script src="//cdnjs.cloudflare.com/ajax/libs/highlight.js/9.12.0/languages/vim.min.js"></script>
        
        <script src="//cdnjs.cloudflare.com/ajax/libs/highlight.js/9.12.0/languages/yaml.min.js"></script>
        
      

      
      
      <script src="https://cdnjs.cloudflare.com/ajax/libs/mathjax/2.7.4/MathJax.js?config=TeX-AMS_CHTML-full" integrity="sha256-GhM+5JHb6QUzOQPXSJLEWP7R73CbkisjzK5Eyij4U9w=" crossorigin="anonymous" async></script>
      
    

    <script src="/js/hugo-academic.js"></script>
    

    
    

    
    
    
    <script id="dsq-count-scr" src="//ackso-net.disqus.com.disqus.com/count.js" async></script>
    

    
    
    <script>hljs.initHighlightingOnLoad();</script>
    

    
    
    <script>
      const search_index_filename = "/index.json";
      const i18n = {
        'placeholder': "Search...",
        'results': "Search Results",
        'no_results': "No results found"
      };
      const content_type = {
        'post': "Posts",
        'project': "Projects",
        'publication' : "Publications",
        'talk' : "Talks"
        };
    </script>
    

    
    

    

    
    

    
    

  </body>
</html>

